package org.acme.mqtt;

import java.util.Arrays;
import java.util.concurrent.CompletionStage;

import javax.enterprise.context.ApplicationScoped;

import org.eclipse.microprofile.reactive.messaging.Incoming;
import org.eclipse.microprofile.reactive.messaging.Outgoing;

import io.smallrye.reactive.messaging.annotations.Broadcast;
import io.smallrye.reactive.messaging.mqtt.MqttMessage;

/**
 * A bean consuming data from the "prices" MQTT topic and applying some conversion.
 * The result is pushed to the "my-data-stream" stream which is an in-memory stream.
 */
@ApplicationScoped
public class PriceConverter {

    private static final double CONVERSION_RATE = 0.88;

    @Incoming("mqtt")
//    public void consume(byte[] payload) {
    public CompletionStage<Void> consume(byte[] message) {
//        System.out.println("Receiving price: " + new String(payload));
        System.out.println("Receiving message: " + new String(message.getPayload()));
        return message.ack();
    }

}
